%% CREATE GRAPHICS

clc
clear all
close all

%% Data

data_x1 = [3; 4; 5; 6; 7; 8; 9; 10; 11];
data_y1 = [0.5; 0.8; 1.4; 0.9; 0.8; 0.9; 1.2; 1.4; 1.8];

data_x2 = [5; 7.5; 8.5; 10; 12];
data_y2 = [1.0; 1.5; 1.3; 1.2; 1.1];

data_x3 = [-2; 3; 4; 5; 6; 7; 8; 9; 10; 11];
data_y3 = [0.5; 0.7; 1.0; 1.6; 1.1; 1.1; 1.2; 1.5; 1.8; 2.1];

data_x4 = [-1; 2; 3];
data_y4 = [1.0; 1.1; 1.3];




%% General Variables

pict_name = 'picture\graphic';  % File Path and File Name of the *.eps
print_eps = 1;                  % Print eps?         0=no 1=yes
show_fig  = 1;                  % Show Plotwindow    0=no 1=yes
close_fig = 0;                  % Close Plotwindow?  0=no 1=yes




%% Plot Variables

% Size and Border
graphic_w = 10.0;             % Width of the Graphic [cm] (5)
graphic_h = 5.0;              % Height of the Graphic [cm] (5)
border_t = 0.75;              % Border top [cm] (0.25)
border_b = 1.00;              % Border bottom [cm] (1.00)
border_l = 1.25;              % Border left [cm] (1.25)
border_r = 0.50;              % Border right [cm] (0.25)
image_offset = 1;             % Location of the Image [cm] (1)

% Font Type and Text Size
text_h0 = 11;                 % Text Height Header [pt] (11)
text_h1 = 10;                 % Text Height Axes and Label [pt] (10)
text_h2 = 8;                  % Text Height Legend [pt] (10)
tfont='Times New Roman';      % Text Font (Times New Roman, crm12, LMRoman12)
%tfont='Calibri';
inte = 'tex';                 % Font Interpreter 'tex'/'latex'

% Header and Labels
header = 'Graphic';           % Header of the Plot
tit = 1;                      % Plot Header? 0=no 1=yes (0)
xlab = '{\itx} [m]';          % Label x-axis  -  for LaTex: xlab = '$x$ [m]';
ylab = '{\itv} [mm]';         % Label y-axis  -  for LaTex: ylab = '$v$ [mm]';

% Legend
lege = {'{\itp} = 1','{\itp} = 2','{\itp} = 3'};  % for LaTex: lege = {'$p$ = 1', ... };

leg = 1;                      % Plot Legend?     0=no 1=yes (1)
leg_loc = 2;                  % Legend location? 1=bot/lef 2=bot/rig 3=top/rig 4=top/lef

% Axis Limits
axis_limitx = ['auto'];       % Axis Limits x [Value Value] ['auto'] ['auto_full']
axis_limity = ['auto'];       % Axis Limits y [Value Value] ['auto'] ['auto_full']
    % Values to Define if axis_limit = ['auto']
    axis_roundx = [10];           % Rounding Value Axis x [Value]
    axis_roundy = [2.5];          % Rounding Value Axis y [Value]
    instr_roundx = [10];          % Rounding Value Data x [Value]
    instr_roundy = [2.5];         % Rounding Value Data y [Value]
    xlimit = [];                  % Enforced Min./Max. Axis Value x [Value Value] []
    ylimit = [];                  % Enforced Min./Max. Axis Value y [Value Value] []
axis_tickx = [5];            % Distance of Ticks x-Axis [Value] or Position of Ticks [Value Value ..] ['auto']
axis_ticky = ['auto'];       % Distance of Ticks y-Axis [Value] or Position of Ticks [Value Value ..] ['auto']
axis_mtickx = 2;             % Number of MinorTicks between Ticks x-Axis [Value] (1)
axis_mticky = 1;             % Number of MinorTicks between Ticks y-Axis [Value] (1)
axes_w = 0.3;                % Line Width of the Axes [pt] (0.3)

% Additional Lines
linesx = [];                 % Position of Lines in x [y-Value y-Value ...] []
linesy = [0];                % Position of Lines in y [x-Value x-Value ...] []
lines_w = 0.3;               % Line Width [pt] (0.3)
lines_t = 6;                 % Line Type, refer to "Lines and Markers" (1)

% Additional Image
image = 'image.png';        % Name of the Image (with path and extension)
im_x = -5;                   % Position x of the Image Center
im_y = 1.5;                  % Position y of the Image Center
im_lx = 8;                   % Width of the Image in the Plot

% Lines and Markers
   % black and white
line = char('-',':','-',':','-.','--','--');                                        % Line type
line_w = [0.3;0.3;0.3;0.3;0.3;0.3;0.3];                                             % Line width
color = [[0 0 0];[0 0 0];[0.5 0.5 0.5];[0.5 0.5 0.5];[0.5 0.5 0.5];[0.5 0.5 0.5]];  % Line color
marker = char('o','s','x','^','v','<','>');                                         % Marker type
mcolor = [[0 0 0];[0 0 0];[0.5 0.5 0.5];[0.5 0.5 0.5];[0.5 0.5 0.5];[0.5 0.5 0.5]]; % Marker color
msize = [3;3;3;3;3;3;3];                                                            % Marker size
   % color
%line = char('-','-','-','-','-','-','-','-');
%line_w = [0.3;0.3;0.3;0.3;0.3;0.3;0.3];
%color = [[0 0 0];[0 0 0.9];[0.8 0 0];[0 0.85 0];[0.5 0.8 0.8];[1 0.5 0];[0.9 0.9 0];[1 0.6 0.6];[0.6 0.6 0.6]];
%marker = char('o','s','x','^','v','<','>');
%mcolor = [[0 0 0];[0 0 0.9];[0.8 0 0];[0 0.85 0];[0.5 0.8 0.8];[1 0.5 0];[0.9 0.9 0];[1 0.6 0.6];[0.6 0.6 0.6]];
%[black];[blue];[red];[light green];[cyan];[orange];[yellow];[light red];[gray]
%msize = [3;3;3;3;3;3;3];

% For line specifications, marker specifications and colors refer to the
% matlab-help and search for "linespec" / "colorspec"




%% Plotdata

% Open Figure
if show_fig ~= 0
    f1=figure;
else
    f1=figure('Visible','off');
end

% Add Image
if exist('image','var')==1
    if exist(image,'file')==2
        i=imread(image);
        colormap(gray)
        h = imagesc(flipud(i),'Clipping','off');
        set(gca,'ydir','normal');
        hold on
    else
        disp('Image does not exist')
        clear image
    end
end


% Plot four Sets of Data
for p=1:4
    data_x = eval(['data_x' num2str(p)]);
    data_y = eval(['data_y' num2str(p)]);
    
    if p <= 3
        %Plot the first three Sets of Data as Lines
        plot(data_x,data_y,line(p,:),'Color',color(p,:),'LineWidth',line_w(p,:));
    else
        %Plot the fourth Set of Data as Markers
        plot(data_x,data_y,marker(p-3,:),'MarkerEdgeColor',mcolor(p-3,:),'MarkerFaceColor',mcolor(p-3,:),'MarkerSize',msize(p-3,:));
    end
    
    
    
    if p==1
        hold on
    end
    
    %Evaluate Axis Limits when axis_limitx = ['auto']
    if isempty(xlimit) && strcmp('auto',axis_limitx)==1
        xlimit(p,:)=[round((floor(min(data_x)/instr_roundx)*instr_roundx)*axis_roundx)/axis_roundx round((ceil(max(data_x)/instr_roundx)*instr_roundx)*axis_roundx)/axis_roundx];
    elseif strcmp('auto',axis_limitx)==1
        xlimit(p,:)=[round((min([xlimit(1) floor(min(data_x)/instr_roundx)*instr_roundx]))*axis_roundx)/axis_roundx round((max([xlimit(2) ceil(max(data_x)/instr_roundx)*instr_roundx]))*axis_roundx)/axis_roundx];
    end
    
    %Evaluate Axis Limits when axis_limity = ['auto']
    if isempty(ylimit) && strcmp('auto',axis_limity)==1
        ylimit(p,:)=[round((floor(min(data_y)/instr_roundy)*instr_roundy)*axis_roundy)/axis_roundy round((ceil(max(data_y)/instr_roundy)*instr_roundy)*axis_roundy)/axis_roundy];
    elseif strcmp('auto',axis_limity)==1
        ylimit(p,:)=[round((min([ylimit(1) floor(min(data_y)/instr_roundy)*instr_roundy]))*axis_roundy)/axis_roundy round((max([ylimit(2) ceil(max(data_y)/instr_roundy)*instr_roundy]))*axis_roundy)/axis_roundy];
    end
    
end


% Additional Text
% For text properties refer to the matlab-help and search for "text properties"
%text(5,2,'\DeltaV_P','FontName',tfont,'FontSize',text_h2,'HorizontalAlignment','center','VerticalAlignment','bottom','Rotation',0,'Interpreter',inte);



%% Plotdesign

% Plot Limits
if strcmp('auto',axis_limitx)==1
    xlim([min(xlimit(:,1)) max(xlimit(:,2))]);
elseif strcmp('auto_full',axis_limitx)~=1
    xlim(axis_limitx);
    xlimit=axis_limitx;
end
if strcmp('auto',axis_limity)==1
    ylim([min(ylimit(:,1)) max(ylimit(:,2))]);
elseif  strcmp('auto_full',axis_limity)~=1
    ylim(axis_limity);
    ylimit=axis_limity;
end

% Image
if exist('image','var')==1
    iminfo = imfinfo(image);
    r = iminfo.Width/iminfo.Height*graphic_h/graphic_w;
    bx = get(gca,'xlim');
    by = get(gca,'ylim');
    dbx = (bx(2)-bx(1));
    dby = (by(2)-by(1));
    im_ly = im_lx/dbx*dby/r;
    set(h,'XData',[im_x-im_lx/2 im_x+im_lx/2],'YData',[im_y-im_ly/2 im_y+im_ly/2])
    clear iminfo r bx by dbx dby im_lx im_ly
end

% Size of Plot
image_w = border_l + graphic_w + border_r;
image_h = border_b + graphic_h + border_t;
set(f1,'Units','centimeters','Position',[image_offset image_offset image_w image_h],'Color','White')
set(get(gcf,'CurrentAxes'),'FontName',tfont,'FontSize',text_h1,'Units','centimeters','Position',[border_l border_b graphic_w graphic_h],'LineWidth',axes_w)

% Ticks
if isnumeric(axis_tickx) && strcmp('auto_full',axis_limitx)~=1
    if length(axis_tickx)==1
        anz_tick=round(abs(max(xlimit(:,2))-min(xlimit(:,1)))/axis_tickx+1);
        clear xtick
        for o=1:anz_tick
            xtick(o)=round((min(xlimit(:,1))+axis_tickx*(o-1))*axis_roundx)/axis_roundx;
        end
    else
        xtick = axis_tickx;
    end
    set(get(gcf,'CurrentAxes'),'xtick',xtick)
end
if isnumeric(axis_ticky) && strcmp('auto_full',axis_limity)~=1
    if length(axis_ticky)==1
        anz_tick=round(abs(max(ylimit(:,2))-min(ylimit(:,1)))/axis_ticky+1);
        clear ytick
        for o=1:anz_tick
            ytick(o)=round((min(ylimit(:,1))+axis_ticky*(o-1))*axis_roundy)/axis_roundy;
        end
    else
        ytick = axis_ticky;
    end
    set(get(gcf,'CurrentAxes'),'ytick',ytick)
end
set(get(gcf,'CurrentAxes'),'TickLength',[0.025 0.025],'FontName',tfont,'FontSize',text_h1)

% Minor Ticks
MinorTickLength = 0.0125;
bx = get(gca,'xlim');
by = get(gca,'ylim');
dbx = (bx(2)-bx(1));
dby = (by(2)-by(1));
if graphic_w > graphic_h
    myticklength = dbx*MinorTickLength;
    mxticklength = myticklength/dbx*dby*graphic_w/graphic_h;
else
    mxticklength = dby*MinorTickLength;
    myticklength = mxticklength/dby*dbx*graphic_h/graphic_w;
end
if axis_mtickx ~=0
     ti=unique([get(gca,'xtick') bx]);
     tispa=(ti(2:end)-ti(1:end-1))/(axis_mtickx+1);
     mxtick=[];
     for o=1:axis_mtickx
          mxtick= horzcat(mxtick,ti(1:end-1)+tispa*o);
     end
     mxtick=sort(mxtick);
     for j=1:size(mxtick,2)
        plot([mxtick(1,j) mxtick(1,j)],[by(1,1) by(1,1)+mxticklength],'-','Color',[0 0 0],'LineWidth',axes_w);
        plot([mxtick(1,j) mxtick(1,j)],[by(1,2) by(1,2)-mxticklength],'-','Color',[0 0 0],'LineWidth',axes_w);
     end
end
if axis_mticky ~=0
     ti=unique([get(gca,'ytick') by]);
     tispa=(ti(2:end)-ti(1:end-1))/(axis_mticky+1);
     mytick=[];
     for o=1:axis_mticky
          mytick= horzcat(mytick,ti(1:end-1)+tispa*o);
     end
     mytick=sort(mytick);
     for j=1:size(mytick,2)
        plot([bx(1,1) bx(1,1)+myticklength],[mytick(1,j) mytick(1,j)],'-','Color',[0 0 0],'LineWidth',axes_w);
        plot([bx(1,2) bx(1,2)-myticklength],[mytick(1,j) mytick(1,j)],'-','Color',[0 0 0],'LineWidth',axes_w);
     end
end

% Labels
xlabel(xlab,'FontName',tfont,'FontSize',text_h1,'Interpreter',inte);
ylabel(ylab,'FontName',tfont,'FontSize',text_h1,'Interpreter',inte);

% Legend
if leg ~= 0
    if leg_loc == 1;
        leg_lo = 'SouthWest';
    elseif leg_loc == 2
        leg_lo = 'SouthEast';
    elseif leg_loc == 3
        leg_lo = 'NorthEast';
    elseif leg_loc == 4
        leg_lo = 'NorthWest';
    else
        leg_lo = 'SouthEast';
        disp('Definition of the legend location incorrect')
    end
    legend(lege,'Location',leg_lo,'FontName',tfont,'FontSize',text_h2,'Interpreter',inte);
    legend('boxoff');
    %legendchange;
end

% Header
if tit ~=0
    title(header,'FontName',tfont,'FontSize',text_h0,'Interpreter',inte)
end

% Additional Lines
if ~isempty(linesx)
    for j=1:size(linesx,2)
        plot(get(gca,'xlim'),[linesx(1,j) linesx(1,j)],line(lines_t,:),'Color',[0 0 0],'LineWidth',lines_w);
    end
end
if ~isempty(linesy)
    for j=1:size(linesy,2)
        plot([linesy(1,j) linesy(1,j)],get(gca,'ylim'),line(lines_t,:),'Color',[0 0 0],'LineWidth',lines_w);
    end
end

if strcmp(inte,'latex')==1 
    p_xla = get(get(gca,'xlabel'),'Position');
    p_yla = get(get(gca,'ylabel'),'Position');
    tick2text(get(gcf,'CurrentAxes'),'ytickoffset',0.01,'xtickoffset',0.02)
    hx = getappdata(get(gcf,'CurrentAxes'), 'XTickText');
    set(hx,'FontName',tfont,'FontSize',text_h1,'Interpreter',inte,'VerticalAlignment','top');
    hy = getappdata(get(gcf,'CurrentAxes'), 'YTickText');
    set(hy,'FontName',tfont,'FontSize',text_h1,'Interpreter',inte,'HorizontalAlignment','right');
    set(get(gca,'xlabel'),'Position',[p_xla(1) p_xla(2)])
    set(get(gca,'ylabel'),'Position',[p_yla(1) p_yla(2)])
    clear p_xla p_yla hx hy
end

hold off

% Save Graphic
if print_eps ~= 0
    saveimg=['export_fig ' '''' pict_name '''' ' -eps -png' ' -nocrop'  ' -m3' ' -q100'];
    eval(saveimg);
end

if close_fig == 1
    close(f1(ishghandle(f1)));
end

disp('Graphic created')

%%
